import csv
import os
import common
import runCRFProperties

def evaluateTag(tag, rows):
    falsePositives = []
    falseNegatives = []
    correct = []
    i = 0
    while i < len(rows):
        row = rows[i]

        word = row[0]
        gold = row[1]
        estimated = row[2]
    
       
        if gold ==  "B-" + tag:
            falseNegativeWord = []
            correctWord = []
            totalAnnotatedWord = []
            totalAnnotatedWord.append(word)
            if estimated == gold:
                correctWord.append(word)
            else:
                falseNegativeWord.append(word)
            i = i + 1
            if i < len(rows):
                row = rows[i]
                word = row[0]
                gold = row[1]
                estimated = row[2]
                while gold == "I-" + tag and i < len(rows):
                    totalAnnotatedWord.append(word)
                    if estimated == gold:
                        correctWord.append(word)
                    else:
                        falseNegativeWord.append(word)
                    i = i + 1
                    if i < len(rows):
                        row = rows[i]
                        word = row[0]
                        gold = row[1]
                        estimated = row[2]

            if len(falseNegativeWord) == 0:
                correct.append(" ".join(correctWord))
            else:
                falsNegStr = " ".join(falseNegativeWord) 
                if len(correctWord) != 0:
                    falsNegStr = falsNegStr + \
                        " (total annotated expression: " + \
                        " ".join(totalAnnotatedWord) + ")" 
                falseNegatives.append(falsNegStr)
        elif estimated == "B-" + tag:
            falsePositiveWord = []
            correctWord = []
            totalEstimatedWord = []
            totalEstimatedWord.append(word)

            if estimated == gold:
                correctWord.add(word)
                print "Borde inte kunna handa"
            else:
                falsePositiveWord.append(word)
            i = i + 1
            if i < len(rows):
                row = rows[i]
                word = row[0]
                gold = row[1]
                estimated = row[2]
            while estimated == "I-" + tag and  i < len(rows):
                totalEstimatedWord.append(word)
                if gold == estimated:
                    correctWord.append(word)
                else:
                    falsePositiveWord.append(word)
                i = i + 1
                if i < len(rows):
                    row = rows[i]
                    word = row[0]
                    gold = row[1]
                    estimated = row[2]
            if len(falsePositiveWord) == 0:
                correct.append("".join(correctWord))
                print "Borde inte kunna handa"
            else:
                falsPosStr = " ".join(falsePositiveWord) 
                if len(correctWord) != 0:
                   falsPosStr = falsPosStr + " (Total estimated word:  " + \
                                          " ".join(totalEstimatedWord) + ")"
                falsePositives.append(falsPosStr)
        else:
            i = i + 1
    return falsePositives, falseNegatives, correct
   
def evaluatefile(outputfile, tag):  
     
    print "Reading information from: " + outputfile
    file = open(outputfile)
    resultReader = csv.reader(file, delimiter='\t', quotechar='|')
    rows = []
    firstRow = 1
    for row in resultReader:
        if row != []:
            numberOfColumns = len(row)
       
            estimated = row[numberOfColumns-1]
            gold = row[numberOfColumns-2]
            word = row[0]

            resultRow =  [word, gold, estimated]
            rows.append(resultRow)
        
    file.close()
    return evaluateTag(tag, rows)

def evaluateDir(dirToEvaluate, tagsToEvaluate, resultFile):
    resultToWrite = open(resultFile, "w")
    files = filter(lambda x: x.endswith(".output"), os.listdir(dirToEvaluate))
    
    for tag in tagsToEvaluate:
        falsePositivesTot = []
        falseNegativesTot = []
        correctTot = []
        for file in files:
             falsePositives, falseNegatives, correct = evaluatefile(dirToEvaluate + "/" + file, tag)
             falsePositivesTot = falsePositivesTot + falsePositives
             falseNegativesTot = falseNegativesTot + falseNegatives
             correctTot = correctTot + correct

        precision = common.doDivision(len(correctTot), len(correctTot) + len(falsePositivesTot))
        recall = common.doDivision(len(correctTot), len(correctTot) + len(falseNegativesTot))
        resultToWrite.write("\n\n************\n" + tag + "\n************\n")
        resultToWrite.write("false positives:\n************\n")
        for el in falsePositivesTot:
            resultToWrite.write(str(el) + "\n")
        resultToWrite.write("\nfalse negatives:\n************\n")
        for el in falseNegativesTot:
            resultToWrite.write(str(el) + "\n")
        resultToWrite.write("\ncorrect:\n************\n")
        for el in correctTot:
            resultToWrite.write(str(el) + "\n")
        resultToWrite.write("\n\nprecision: " +  str(precision) + "\n")
        resultToWrite.write("recall: " + str(recall) + "\n\n")
        
#evaluatefile("outputdata/test.output", ["test1", "test2"], "outputdata")
    
#evaluatefile("testFilesAndScripts/testfeatures.txt", ["diagnosis"], "testFileAndScripts/featurtestoutput")

#evaluateDir("resultsFromAll/run6_2_smaller_c/crfoutputfolder", ['Clinical_Finding', 'Body_part'], "featurtestoutput.txt")

evaluateDir("resultsFromAll/serie2/crfoutputfolder", ["First_Name", "Health_Care_Unit"], "testFilesAndScripts/featurtestoutput.txt")
