import csv
import os
import common
import runCRFProperties

def evaluateTag(tag, rows):
    print tag
    falsePositives = []
    falseNegatives = []
    correct = []
    i = 0
    while i < len(rows):
        row = rows[i]

        word = row[0]
        gold = row[1]
        estimated = row[2]
    
       
        if gold ==  "B-" + tag:
            falseNegativeWord = []
            correctWord = []
            totalAnnotatedWord = []
            totalAnnotatedWord.append(word)
            if estimated == gold:
                correctWord.append(word)
            else:
                falseNegativeWord.append(word)
            i = i + 1
            if i < len(rows):
                row = rows[i]
                word = row[0]
                gold = row[1]
                estimated = row[2]
                while gold == "I-" + tag and i < len(rows):
                    totalAnnotatedWord.append(word)
                    if estimated == gold:
                        correctWord.append(word)
                    else:
                        falseNegativeWord.append(word)
                    i = i + 1
                    if i < len(rows):
                        row = rows[i]
                        word = row[0]
                        gold = row[1]
                        estimated = row[2]

            if len(falseNegativeWord) == 0:
                correct.append(" ".join(correctWord))
            else:
                falsNegStr = " ".join(falseNegativeWord) 
                if len(correctWord) != 0:
                    falsNegStr = falsNegStr + \
                        " (correct: '" + " ".join(correctWord) + "', in the annotated expression: '" + \
                        " ".join(totalAnnotatedWord) + "')" 
                falseNegatives.append(falsNegStr)
        elif estimated == "B-" + tag:
            falsePositiveWord = []
            correctWord = []
            totalEstimatedWord = []
            totalEstimatedWord.append(word)

            if estimated == gold:
                correctWord.add(word)
                print "Borde inte kunna handa"
            else:
                falsePositiveWord.append(word)
            i = i + 1
            if i < len(rows):
                row = rows[i]
                word = row[0]
                gold = row[1]
                estimated = row[2]
            while estimated == "I-" + tag and  i < len(rows):
                totalEstimatedWord.append(word)
                if gold == estimated:
                    correctWord.append(word)
                else:
                    falsePositiveWord.append(word)
                i = i + 1
                if i < len(rows):
                    row = rows[i]
                    word = row[0]
                    gold = row[1]
                    estimated = row[2]
            if len(falsePositiveWord) == 0:
                correct.append("".join(correctWord))
                print "Borde inte kunna handa"
            else:
                falsPosStr = " ".join(falsePositiveWord) 
                if len(correctWord) != 0:
                   falsPosStr = falsPosStr + " (Of the estimated word " + \
                                          " ".join(totalEstimatedWord) + " the following is correct: " + \
                                          " ".join(correctWord) + ")"
                falsePositives.append(falsPosStr)
        else:
            i = i + 1
    return falsePositives, falseNegatives, correct
   
def evaluatefile(outputfile, tag):  
     
    print "Reading information from: " + outputfile
    file = open(outputfile)
    resultReader = csv.reader(file, delimiter='\t', quotechar='|')
    rows = []
    firstRow = 1
    for row in resultReader:
        if row != []:
            numberOfColumns = len(row)
       
            estimated = row[numberOfColumns-1]
            gold = row[numberOfColumns-2]
            word = row[0]

            resultRow =  [word, gold, estimated]
            rows.append(resultRow)
        
    file.close()
    res =  evaluateTag(tag, rows)
    return res

def evaluateDir(dirToEvaluate, tagsToEvaluate, resultFile):
    outputfeaturefile = "features_rulebased_replaced.txt"
    resultToWrite = open(resultFile, "w")
    files = [outputfeaturefile]
    posDict = {}
    negDict = {}
    corDict = {}
    
    for tag in tagsToEvaluate:
        posDict = {}
        negDict = {}
        corDict = {}
        print tag
        falsePositivesTot = []
        falseNegativesTot = []
        correctTot = []
        nrFalsePos = 0
        nrFalseNeg = 0
        nrCorrect = 0

        
        for file in files:
             falsePositives, falseNegatives, correct = evaluatefile(dirToEvaluate + "/" + file, tag)
             falsePositivesTot = falsePositivesTot + falsePositives
             falseNegativesTot = falseNegativesTot + falseNegatives
             correctTot = correctTot + correct
        for el in falsePositivesTot:
            common.addBag(el, posDict)
        for el in falseNegativesTot:
            common.addBag(el, negDict)
        for el in correctTot:
            common.addBag(el, corDict)
        
        print falseNegativesTot
        resultToWrite.write("\n\n************\n" + tag + "\n************\n")
        resultToWrite.write("**********************************************\n")
        resultToWrite.write("**********************************************\n")
        resultToWrite.write("**********************************************\n")
        resultToWrite.write("\nfalse positives:\n")
        resultToWrite.write("**********************************************\n")
        for key, value in posDict.items():
            resultToWrite.write(str(key) + '\t' + str(value) +  "\n")
            nrFalsePos = nrFalsePos + value
        resultToWrite.write("Total nrFalsePos " + str(nrFalsePos)  +  "\n")
        resultToWrite.write("\nfalse negatives:\n")
        resultToWrite.write("**********************************************\n")
        for key, value in negDict.items():
            resultToWrite.write(str(key) + '\t' + str(value)+  "\n")
            nrFalseNeg = nrFalseNeg + value
        resultToWrite.write("Total nrFalseNeg " + str(nrFalseNeg)  +  "\n")
        resultToWrite.write("\ncorrect:\n")
        resultToWrite.write("**********************************************\n")
        for key, value in corDict.items():
            resultToWrite.write(str(key) + '\t' + str(value)+  "\n")
            nrCorrect = nrCorrect + value
        resultToWrite.write("Total nrCorrect " + str(nrCorrect)  +  "\n")
        resultToWrite.write("\n**********************************************\n")
        precision = float(nrCorrect)/float(nrFalsePos + nrCorrect)
        recall = float(nrCorrect)/float(nrFalseNeg + nrCorrect)
        resultToWrite.write("\nPrecision: " + str(precision) + "\n")
        resultToWrite.write("\nRecall: " + str(recall) + "\n")
evaluateDir("resultsFromAll/ruleBased", ["Diagnosis_proper", "Finding", "Body_part"], "resultsFromAll/ruleBased/listFalseoutput.txt")
