import generateFeatures
import commands
import common
import foldEvaluationConfig.configForSerie
import csv
import os
import processConllOutput
import calculateAndPrintResult
import datetime
import runCRFProperties
import ruleBasedPreprocessing

def runRuleBased(name):

    resultsAllRuns = runCRFProperties.resultsAllRuns
    outputForRun = resultsAllRuns + "/" + name
    #resultsFolder =  runCRFProperties.resultsFolder

    common.ensure_dir(resultsAllRuns)
    common.ensure_dir(outputForRun)

    timestarted = datetime.datetime.now()

    NOMATCH = foldEvaluationConfig.configForSerie.NOMATCH
    datafolder = foldEvaluationConfig.configForSerie.datafolder
    tagsToEvaluate = foldEvaluationConfig.configForSerie.tagsToEvaluate
    config = common.getImport(name, name + "_config")
    toChange = config.tagsToChange
   
    #resultsFolder = config.resultsFolder
    outputfile = outputForRun + "/features_rulebased.txt"
    outputfileReplaced = outputForRun + "/features_rulebased_replaced.txt"
    evaluationfile = outputForRun + "/evaluationfile.txt"
    resultFile =  outputForRun + "/testRuleBased.txt"
    finalResultFileName = outputForRun + "/finalResultFile.txt"

    conllResults = []

    totText = ""
    for filename in os.listdir(datafolder):
        if not filename.startswith("."):
            readFrom = open(datafolder + "/"+ filename, "r")
            totText = totText + readFrom.read() + '\n'
            readFrom.close()
    totText = totText.strip()
    writeTo = open(evaluationfile, "w")
    writeTo.write(totText)
    writeTo.close()
    generateFeatures.generateFeatures(evaluationfile, outputfile, name, combineCategories = True, reversed = True)

    featuresToReplace = open(outputfile, "r")
    featuresReplaced = open(outputfileReplaced, "wb")
    delimit='\t'
    rowReader = csv.reader(featuresToReplace, delimiter=delimit, quotechar='|')
    rows = []
    for r in rowReader:
        rows.append([common.getUnicodedWordFromUTFCoded(el) for el in r])

    rows = ruleBasedPreprocessing.doPreprocess(rows, NOMATCH, tagsToEvaluate, outputForRun)
    lastResult = NOMATCH
    firstRow = True
    for row in rows:
        if row != []:
            if not firstRow:
                featuresReplaced.write('\n')
                pass
            else:
                firstRow = False
            lastColumnn = row[len(row) - 1]
            print lastColumnn,
            for key in toChange.keys():
                if lastColumnn == key:
                    lastColumnn = toChange[key]
            prefix = ""
            if lastColumnn != NOMATCH:
                if lastColumnn != lastResult: # if there are two of the equal class in a row, this won't work, but ok for now
                    prefix = "B-"
                else:
                    prefix = "I-"
            lastResult = lastColumnn
            newRow = row[0:len(row) - 1] + [prefix + lastColumnn]
            toWrite = ""
            for el in newRow:
                toWrite = toWrite + el + delimit
            featuresReplaced.write(common.getUTFCodedWord(toWrite.strip()))
        else:
            pass
            #featuresReplaced.write('\n')

    featuresToReplace.close()
    featuresReplaced.close()

    
    conllResults.append(processConllOutput.askConllScript(outputfileReplaced, resultFile))
    #print "Using conll script for file: ", outputfileReplaced
    #conllCommand = "./conlleval.pl -d '\t' < " + outputfileReplaced + " > " + resultFile
    #print "Running command " + conllCommand
    #print commands.getoutput(conllCommand)
    #print processConllOutput.askConllScript(outputfileReplaced, resultFile)

    conllCommand = "./conlleval.pl -d '\t' -l < " + outputfileReplaced + " > "  + resultFile +  ".tex"
    print "Running command " + conllCommand
    print commands.getoutput(conllCommand)

    finalResultFile = open(finalResultFileName, "w")
    options = "ruleBased"
    result =  calculateAndPrintResult.calculateAndPrintResult(tagsToEvaluate, conllResults, finalResultFile, timestarted, options, name)
    finalResultFile.close()
    return result

#runRuleBased("ruleBased")
